/******************************************************************************
* Dis8051 v2.0 - 8051 Instructions header file.                               *
******************************************************************************/

/*
* The first bit of each line
*/

char Instr[256][15]=
{
	"NOP","AJMP ","LJMP ","RR A","INC A","INC ","INC @R0",
	"INC @R1","INC R0","INC R1","INC R2","INC R3","INC R4",
	"INC R5","INC R6","INC R7","JBC ","ACALL ","LCALL ",
	"RRC A","DEC A","DEC ","DEC @R0","DEC @R1","DEC R0","DEC R1",
	"DEC R2","DEC R3","DEC R4","DEC R5","DEC R6","DEC R7","JB ",
	"AJMP ","RET","RL A","ADD A,#","ADD A,","ADD A,@R0",
	"ADD A,@R1","ADD A,R0","ADD A,R1","ADD A,R2","ADD A,R3",
	"ADD A,R4","ADD A,R5","ADD A,R6","ADD A,R7","JNB ","ACALL ",
	"RETI","RLC A","ADDC A,#","ADDC A,","ADDC A,@R0","ADDC A,@R1",
	"ADDC A,R0","ADDC A,R1","ADDC A,R2","ADDC A,R3","ADDC A,R4",
	"ADDC A,R5","ADDC A,R6","ADDC A,R7","JC ","AJMP ","ORL ",
	"ORL ","ORL A,#","ORL A,","ORL A,@R0","ORL A,@R1","ORL A,R0",
	"ORL A,R1","ORL A,R2","ORL A,R3","ORL A,R4","ORL A,R5",
	"ORL A,R6","ORL A,R7","JNC ","ACALL ","ANL ","ANL ","ANL A,#",
	"ANL A,","ANL A,@R0","ANL A,@R1","ANL A,R0","ANL A,R1",
	"ANL A,R2","ANL A,R3","ANL A,R4","ANL A,R5","ANL A,R6",
	"ANL A,R7","JZ ","AJMP ","XRL ","XRL ","XRL A,#","XRL A,",
	"XRL A,@R0","XRL A,@R1","XRL A,R0","XRL A,R1","XRL A,R2",
	"XRL A,R3","XRL A,R4","XRL A,R5","XRL A,R6","XRL A,R7","JNZ ",
	"ACALL ","ORL C,","JMP @A+DPTR","MOV A,#","MOV ","MOV @R0,#",
	"MOV @R1,#","MOV R0,#","MOV R1,#","MOV R2,#","MOV R3,#",
	"MOV R4,#","MOV R5,#","MOV R6,#","MOV R7,#","SJMP ","AJMP ",
	"ANL C,","MOVC A,@A+PC","DIV AB","MOV ","MOV ","MOV ","MOV ",
	"MOV ","MOV ","MOV ","MOV ","MOV ","MOV ","MOV ","MOV DPTR,#",
	"ACALL ","MOV ","MOVC A,@A+DPTR","SUBB A,#","SUBB A,",
	"SUBB A,@R0","SUBB A,@R1","SUBB A,R0","SUBB A,R1","SUBB A,R2",
	"SUBB A,R3","SUBB A,R4","SUBB A,R5","SUBB A,R6","SUBB A,R7",
	"ORL C,/","AJMP ","MOV C,","INC DPTR","MUL AB","DB #A5H",
	"MOV @R0,","MOV @R1,","MOV R0,","MOV R1,","MOV R2,","MOV R3,",
	"MOV R4,","MOV R5,","MOV R6,","MOV R7,","ANL C,/","ACALL ",
	"CPL ","CPL C","CJNE A,#","CJNE A,","CJNE @R0,#","CJNE @R1,#",
	"CJNE R0,#","CJNE R1,#","CJNE R2,#","CJNE R3,#","CJNE R4,#",
	"CJNE R5,#","CJNE R6,#","CJNE R7,#","PUSH ","AJMP ","CLR ",
	"DB #C3H","SWAP A","XCH A,","XCH A,@R0","XCH A,@R1","XCH A,R0",
	"XCH A,R1","XCH A,R2","XCH A,R3","XCH A,R4","XCH A,R5",
	"XCH A,R6","XCH A,R7","POP ","ACALL ","SETB ","SETB C","DA A",
	"DJNZ ","XCHD A,@R0","XCHD A,@R1","DJNZ R0,","DJNZ R1,",
	"DJNZ R2,","DJNZ R3,","DJNZ R4,","DJNZ R5,","DJNZ R6,",
	"DJNZ R7,","MOVX A,@DPTR","AJMP ","MOVX A,@R0","MOVX A,@R1",
	"CLR A","MOV A,","MOV A,@R0","MOV A,@R1","MOV A,R0","MOV A,R1",
	"MOV A,R2","MOV A,R3","MOV A,R4","MOV A,R5","MOV A,R6","MOV A,R7",
	"MOVX @DPTR,A","ACALL ","MOVX @R0,A","MOVX @R1,A","CPL A",
	"MOV ","MOV @R0,A","MOV @R1,A","MOV R0,A","MOV R1,A","MOV R2,A",
	"MOV R3,A","MOV R4,A","MOV R5,A","MOV R6,A","MOV R7,A"
};


/*
*  Argument types
*  ~~~~~~~~~~~~~~
*  - = No Arguments
*  D = Data, prints XXH
*  B = Bit Address
*  R = Relative address
*  A = Direct Address
*  J = 11-bit absoloute address
*  K = 16-bit absoloute address
*  L = 16-bit data, prints XXXXH
*  W = Warning (Undefined command)
*
*/
char arg1[16][17]=
{
	"-JK--A----------",	/*  00-0F  */
	"BJK--A----------",	/*  10-1F  */
	"BJ--DA----------",	/*  20-2F  */
	"BJ--DA----------",	/*  30-3F  */
	"RJAADA----------",	/*  40-4F  */
	"RJAADA----------",	/*  50-5F  */
	"RJAADA----------",	/*  60-6F  */
	"RJB-DADDDDDDDDDD",	/*  70-7F  */
	"RJB--AAAAAAAAAAA",	/*  80-8F  */
	"LJB-DA----------",	/*  90-9F  */
	"BJB--WAAAAAAAAAA",	/*  A0-AF  */
	"BJB-DADDDDDDDDDD",	/*  B0-BF  */
	"AJB--A----------",	/*  C0-CF  */
	"AJB--A--RRRRRRRR",	/*  D0-DF  */
	"-J---A----------",	/*  E0-EF  */
	"-J---A----------"	/*  F0-FF  */
};


/*
* Which rows have extra text on them?
*/
#define NUM_EXTRAS	36

char exrows[NUM_EXTRAS]=
{
	0x10,0x20,0x30,0x42,0x43,0x52,0x53,0x62,0x63,0x75,0x85,0x86,
	0x87,0x88,0x89,0x8A,0x8B,0x8C,0x8D,0x8E,0x8F,0x92,0xB4,0xB5,
	0xB6,0xB7,0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF,0xD5,0xF5
};

char extra[NUM_EXTRAS][5]=
{
	",", ",", ",", ",A", ",#", ",A", ",#", ",A", ",#", ",#", ",",
	",@R0",",@R1",",R0",",R1",",R2",",R3",",R4",",R5",",R6",",R7",
	",C", ",", ",", ",", ",", ",", ",", ",", ",", ",", ",", ",",
	",", ",", ",A"
};


/*
* Which rows have another argument?
*/
#define NUM_ARG2	21
#define NUM_ARG2PP	22

char arg2rows[NUM_ARG2]=
{
	0x10,0x20,0x30,0x43,0x53,0x63,0x75,0x85,0xB4,0xB5,0xB6,0xB7,
	0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF,0xD5
};

char arg2[NUM_ARG2PP]="RRRDDDDARRRRRRRRRRRRR";

/*
* The Special Function Registers
*/
#define NUM_SFRS	26
char SFRNames[NUM_SFRS][7]=
{
	"ACC","B","PSW","SP","DPH","DPL","P0","P1","P2","P3",
	"IP","IE","TMOD","T2CON","TCON","TH0","TL0","TH1","TL1",
	"TH2","TL2","RCAP2H","RCAP2L","SCON","SBUF","PCON"
};

char SFRAddrs[NUM_SFRS]=
{
	0xE0,0xF0,0xD0,0x81,0x83,0x82,0x80,0x90,0xA0,0xB0,0xB8,0xA8,0x89,
	0xC8,0x88,0x8C,0x8A,0x8D,0x8B,0xCD,0xCC,0xCB,0xCA,0x98,0x99,0x87
};

/*
* The directly addressable bits from 0x80 to 0xFF
* a '-' indicates that you can't do it.
*/
char BitNames[128][6]=
{
	"P0.0","P0.1","P0.2","P0.3","P0.4","P0.5","P0.6","P0.7",
	"IT0","IE0","IT1","IE1","TR0","TF0","TR1","TF1",
	"P1.0","P1.1","P1.2","P1.3","P1.4","P1.5","P1.6","P1.7",
	"RI","TI","RB8","TB8","REN","SM2","SM1","SM0",
	"P2.0","P2.1","P2.2","P2.3","P2.4","P2.5","P2.6","P2.7",
	"EX0","ET0","EX1","ET1","ES","-","-","EA",
	"P3.0","P3.1","P3.2","P3.3","P3.4","P3.5","P3.6","P3.7",
	"PX0","PT0","PX1","PT1","PS","-","-","-",
	"-","-","-","-","-","-","-","-",
	"CP","C","TR2","EXEN2","TCLK","RCLK","EXF2","TF2",
	"P","-","OV","RS0","RS1","FO","AC","CY",
	"-","-","-","-","-","-","-","-",
	"ACC.0","ACC.1","ACC.2","ACC.3","ACC.4","ACC.5","ACC.6","ACC.7",
	"-","-","-","-","-","-","-","-",
	"B.0","B.1","B.2","B.3","B.4","B.5","B.6","B.7",
	"-","-","-","-","-","-","-","-"
};


/******************************************************************************
* End of 8051.H								      *
******************************************************************************/
