/******************************************************************************
* Hex2Bin v2.0								      *
*  v1.1 fixed a bug which failed to read some values - v1.0 is FAULTY	      *
*  v2.0 is a true free-form hex reader.
******************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


/******************************************************************************
* Globals								      *
******************************************************************************/

typedef unsigned char BOOL;
#define TRUE	1
#define FALSE	0


/******************************************************************************
* Functions 								      *
******************************************************************************/

int GetByte(FILE *Fh)
{
	unsigned char value[]="0123456789ABCDEF";
	int i,j,Byte;
	char nybble;

	do
	{
		nybble=0xF0;
		i=getc(Fh);
		if(i==EOF) return(EOF);
		i=toupper(i);
		for(j=0;j<16;j++) if(i==value[j]) nybble=j;
	}
	while(nybble==0xF0);
	Byte=nybble*16;

	do
	{
		nybble=0xF0;
		i=getc(Fh);
		if(i==EOF) return(EOF);
		i=toupper(i);
		for(j=0;j<16;j++) if(i==value[j]) nybble=j;
	}
	while(nybble==0xF0);
	Byte+=nybble;

	return(Byte);
}

main(int argc,char *argv[])
{
	FILE *srce_Fh,*dest_Fh;
	BOOL Success=TRUE;
	int i;

	if(argc!=3)
	{
		printf("\nHex2Bin v2.0, by Gary Benson.");
		printf("\n (C) Copyright 1997-1998 Gary Benson, All Rights Reserved.\n");
		printf("\nFormat: Hex2Bin <source_file> <dest_file>\n\n");

		exit(EXIT_FAILURE);
	}

	srce_Fh=fopen(argv[1],"rb");
	if(srce_Fh)
	{
		dest_Fh=fopen(argv[2],"wb");
		if(dest_Fh)
		{
			i=GetByte(srce_Fh);
			while((i!=EOF)&&(Success))
			{
				putc(i,dest_Fh);
				if(ferror(dest_Fh)) Success=FALSE;
				i=GetByte(srce_Fh);
			}
			if(Success) printf("Hex2Bin: Done.");
			else printf("Hex2Bin: File error writing %s.",argv[2]);
			fclose(dest_Fh);
		}
		else printf("Hex2Bin: Can't write to file %s.",argv[2]);
		fclose(srce_Fh);
	}
	else printf("Hex2Bin: Can't open file %s.",argv[1]);

	if(!Success)
	{
		remove(argv[2]);
		exit(EXIT_FAILURE);
	}
	else exit(EXIT_SUCCESS);
}

/******************************************************************************
* End of HEX2BIN.C							      *
******************************************************************************/
